﻿using System;
using System.Drawing;
using System.Timers;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 경고 폼
    /// </summary>
    public partial class WarningForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 타이머
        /// </summary>
        private System.Timers.Timer timer;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 메시지 - Message

        /// <summary>
        /// 메시지
        /// </summary>
        public string Message { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - WarningForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public WarningForm()
        {
            int left = Screen.PrimaryScreen.WorkingArea.Width  - Width - 20;
            int top  = Screen.PrimaryScreen.WorkingArea.Height - Height;

            DesktopLocation = new Point(left, top);

            Height = 2;

            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            Rectangle primaryScreenRectangle = Screen.PrimaryScreen.Bounds;

            Location = new Point
            (
                primaryScreenRectangle.Width  - Width,
                primaryScreenRectangle.Height - Height
            );

            this.messageLinkLabel.Text = Message;

            this.timer = new System.Timers.Timer(2);

            this.timer.Elapsed += timer_Elapsed1;

            this.timer.Start();
        }

        #endregion
        #region 타이머 경과시 처리하기 1 - timer_Elapsed1(sender, e)

        /// <summary>
        /// 타이머 경과시 처리하기 1
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void timer_Elapsed1(object sender, ElapsedEventArgs e)
        {
            if(Height < 130)
            {
                Height++;

                Application.DoEvents();

                Top--;

                Application.DoEvents();
            }
            else
            {
                this.timer.Stop();

                this.timer.Elapsed -= timer_Elapsed1;

                this.timer.Elapsed += timer_Elapsed2;

                this.timer.Interval = 3000;

                this.timer.Start();
            }
        }

        #endregion
        #region 타이머 경과시 처리하기 2 - timer_Elapsed2(sender, e)

        /// <summary>
        /// 타이머 경과시 처리하기 2
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void timer_Elapsed2(object sender, ElapsedEventArgs e)
        {
            while(Height > 2)
            {
                Height--;

                Application.DoEvents();

                Top++;

                Application.DoEvents();
            }

            Close();
        }

        #endregion
        #region 닫기 픽처 박스 마우스 이동시 처리하기 - closePictureBox_MouseMove(sender, e)

        /// <summary>
        /// 닫기 픽처 박스 마우스 이동시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void closePictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            this.closePictureBox.Image = Properties.Resources.close_over;
        }

        #endregion
        #region 닫기 픽처 박스 마우스 DOWN 처리하기 - closePictureBox_MouseDown(sender, e)

        /// <summary>
        /// 닫기 픽처 박스 마우스 DOWN 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 발생자</param>
        private void closePictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            this.closePictureBox.Image = Properties.Resources.close_down;
        }

        #endregion
        #region 닫기 픽처 박스 클릭시 처리하기 - closePictureBox_Click(sender, e)

        /// <summary>
        /// 닫기 픽처 박스 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void closePictureBox_Click(object sender, EventArgs e)
        {
            Close();
        }

        #endregion
        #region 닫기 픽처 박스 마우스 이탈시 처리하기 - closePictureBox_MouseLeave(sender, e)

        /// <summary>
        /// 닫기 픽처 박스 마우스 이탈시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void closePictureBox_MouseLeave(object sender, EventArgs e)
        {
            this.closePictureBox.Image = Properties.Resources.close_normal;
        }

        #endregion
        #region 메시지 링크 레이블 링크 클릭시 처리하기 - messageLinkLabel_LinkClicked(sender, e)

        /// <summary>
        /// 메시지 링크 레이블 링크 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void messageLinkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Close();
        }

        #endregion
    }
}